
function [dist] = FDist_Pair_patches(Ori_image,RO_image,patch_size)
%clear all
%close all
%clc
%load('Opatches');
%load('RPatches');
%patch_size = 20;

%Ori_image = OPatches.R1;
%RO_image = RPatches.R1;
 % figure;
 % imshow(Ori_image);
 % figure;
 % imshow(RO_image);
  [ori_height,ori_width,dims] = size(Ori_image);
  [ro_height,ro_width,dims] = size(RO_image);
  
  if (ori_width < (2*patch_size+1)) || (ro_width<(2*patch_size+1))  patch_size = 10; end
  if (ori_height < (2*patch_size+1)) || (ro_height<(2*patch_size+1)) patch_size = 10; end
  if ((ori_width <= 20)|| (ori_height <= 20) || (ro_width <= 20) || (ro_height <= 20)) dist.SSIM = 0; dist.QMOS = 0; return; end;
  if (ori_width < 400) ori_step = 10; ret_step = 20; 
  else ori_step = 20; ret_step = 30;
  end
  
  %% patches from original image
  Low_limit_height = patch_size + 1;
  High_limit_height = ori_height - patch_size;
  Low_limit_width = patch_size + 1;
  High_limit_width = ori_width - patch_size;
  ori_num = 0;
  
  for i = Low_limit_height : ori_step : High_limit_height
      for j = Low_limit_width : ori_step : High_limit_width
          temp = Ori_image(i-patch_size:i+patch_size,j-patch_size:j+patch_size,:);
        %  figure;
        %  imshow(temp);
          ori_num = ori_num + 1;
          ori_patches(:,ori_num) = temp(:);          
      end     
  end

%% patches from target image

  Low_limit_height = patch_size + 1;
  High_limit_height = ro_height - patch_size;
  Low_limit_width = patch_size + 1;
  High_limit_width = ro_width - patch_size;
  ro_num = 0;
    for i = Low_limit_height : ret_step : High_limit_height
      for j = Low_limit_width : ret_step :  High_limit_width
          
          temp = RO_image(i-patch_size:i+patch_size,j-patch_size:j+patch_size,:);
          %figure;
          %imshow(temp);
          ro_num = ro_num + 1;
          ro_patches(:,ro_num) = temp(:);
          temp_ro = repmat(temp(:),1,ori_num);
          dist_all(ro_num,:) = sum((temp_ro - ori_patches).^2)/((patch_size*2).^2);
          Min_dist = min(dist_all(ro_num,:));
          Index_min = find(dist_all(ro_num,:) == Min_dist);
          Best_index = Index_min(1);
          best_ori_patch(:,ro_num) = ori_patches(:,Best_index);
      %    x = reshape(best_ori_patch(ro_num,:),patch_size*2+1,patch_size*2+1,3);
      end     
    end
   % disp('ok');
%    tic
    for i = 1 : ro_num
        ro_pair = ro_patches(:,i);
        ori_pair = best_ori_patch(:,i);
        ro = reshape(ro_pair,patch_size*2+1,patch_size*2+1,3);
        ori = reshape(ori_pair,patch_size*2+1,patch_size*2+1,3);
      %  figure(3);
    %    subplot(1,2,1); imshow(ro);
     %   subplot(1,2,2);imshow(ori);
       % disp('success');
        [L2_dist,SSIM_dist] = L2SSIM_ful(ori,ro);
        SSIM(i) = SSIM_dist; 
        
        R = rgb2gray(double(ori)/2^8);
       % R = rgb2gray(R);
        T = rgb2gray(double(ro)/2^8);
       % T = rgb2gray(T); 
      %  tic
       res = Contents_fun(T,R); 
       QMOS(i) = res.Q_MOS;       
      %  toc
    end
  %  toc
    dist.SSIM = sum(SSIM)./ro_num;
    dist.QMOS = sum(QMOS)./ro_num;
    clear ro_patches;
    clear ori_patches;
    clear dist_all;
    
    % disp('success');
    
end