function [Patches] = Getpatches(image, imp)

 [height,width] = size(imp);
 [L,num] = bwlabeln(imp);
 T = regionprops(L,'basic');
 B = [T.BoundingBox];
 
 x1 = round(B(1,1));
 y1 = round(B(1,2));
 x2 = round(B(1,1) + B(1,3));
 y2 = round(B(1,2) + B(1,4));

%  figure;
%  imshow(image);
% line([x1,x1],[y1,y2],'Marker','.','LineStyle','-','color','r','linewidth',3);
% line([x2,x2],[y1,y2],'Marker','.','LineStyle','-','color','r','linewidth',3);
% line([x1,x2],[y1,y1],'Marker','.','LineStyle','-','color','r','linewidth',3);
% line([x1,x2],[y2,y2],'Marker','.','LineStyle','-','color','r','linewidth',3);
 R1 = image(1:y1,1:x1,:);
 R2 = image(1:y1,x1+1:x2,:);
 R3 = image(1:y1,x2+1:width,:);
 R4 = image(y1+1:y2,1:x1,:);
 R5 = image(y1+1:y2,x1+1:x2,:);
 R6 = image(y1+1:y2,x2+1:width,:);
 R7 = image(y2+1:height,1:x1,:);
 R8 = image(y2+1:height,x1+1:x2,:);
 R9 = image(y2+1:height,x2+1:width,:);
 
 
Patches.R1 = R1;
Patches.R2 = R2;
Patches.R3 = R3;
Patches.R4 = R4;
Patches.R5 = R5;
Patches.R6 = R6;
Patches.R7 = R7;
Patches.R8 = R8;
Patches.R9 = R9;

% figure; imshow(Patches.R1);
% figure; imshow(Patches.R2);
% figure; imshow(Patches.R3);
% figure; imshow(Patches.R4);
% figure; imshow(Patches.R5);
% figure; imshow(Patches.R6);
% figure; imshow(Patches.R7);
% figure; imshow(Patches.R8);
% figure; imshow(Patches.R9);
%figure(4);
%subplot(3,3,1);imshow(Patches.R1);
%subplot(3,3,2);imshow(Patches.R2);
%subplot(3,3,3);imshow(Patches.R3);
%subplot(3,3,4);imshow(Patches.R4);
%subplot(3,3,5);imshow(Patches.R5);
%subplot(3,3,6);imshow(Patches.R6);
%subplot(3,3,7);imshow(Patches.R7);
%subplot(3,3,8);imshow(Patches.R8);
%subplot(3,3,9);imshow(Patches.R9);


end