function [L2_dist,SSIM_dist] = L2SSIM_ful(ori_patch,ro_ori_patch)
 % the L2 distance between two patches
        bi_ori_patch(:,:,1) = double(ori_patch(:,:,1))./255.0;
        bi_ori_patch(:,:,2) = double(ori_patch(:,:,2))./255.0;
        bi_ori_patch(:,:,3) = double(ori_patch(:,:,3))./255.0;
%         figure;
%         imshow(bi_ori_patch);
        bi_ro_patch(:,:,1) = double(ro_ori_patch(:,:,1))./255.0;
        bi_ro_patch(:,:,2) = double(ro_ori_patch(:,:,2))./255.0;
        bi_ro_patch(:,:,3) = double(ro_ori_patch(:,:,3))./255.0;
%         figure;
%         imshow(bi_ro_patch);
        [rows,cols,dims] = size(ro_ori_patch);
        
        temp_L2 = sqrt((bi_ori_patch(:,:,1) - bi_ro_patch(:,:,1)).^2 + (bi_ori_patch(:,:,2) - bi_ro_patch(:,:,2)).^2 + (bi_ori_patch(:,:,3) - bi_ro_patch(:,:,3)).^2);
        L2_dist = 1 - sum(sum(temp_L2))/(rows*cols);
        
  % the SSIM distance between two patches
        gray_ori_patch = rgb2gray(ori_patch);
%         figure;
%         imshow(gray_ori_patch);
        gray_ro_ori_patch = rgb2gray(ro_ori_patch);
%         figure;
%         imshow(gray_ro_ori_patch);
        [SSIM_dist SSIM_map]= ssim_index(gray_ori_patch,gray_ro_ori_patch);
        
        
   % 