function [rec_patch flag] = ransac_sift(patch_ori,patch_resize)

 [m n] = size(patch_ori);
 [fa da] = vl_sift(single(patch_ori));
 [fb db] = vl_sift(single(patch_resize));
 [match score] = vl_ubcmatch(da,db);
  scalea = fa(3,match(1,:));
  [scale_sort perm] = sort(scalea,'descend') ;
   match_sort = match(:,perm);
   
 region_fa = fa(:,match_sort(1,:));
 region_fb = fb(:,match_sort(2,:));
 K=size(region_fa,2);
 if (K>8 & m>80)
     
 pts2 = [];
 pts1 = [];
pts2(1,1:K) = round(region_fa(1,1:K));
pts2(2,1:K) = round(region_fa(2,1:K));

pts1(1,1:K) = round(region_fb(1,1:K));
pts1(2,1:K) = round(region_fb(2,1:K));

[H_sift corrPtIdx] = findHomography(pts1,pts2);
if H_sift==0
     rec_patch = patch_resize;
     flag = 1;
else
rec_patch= imTransD(patch_resize, H_sift, [m n]);
flag = 0;
end
if length(corrPtIdx)<6
    flag = 1;
end
 else
     rec_patch = patch_resize;
     flag = 1;
 end
%figure(6);imshow(rec_patch,[]) ;
 
 