 function [all_Dist] = myLayoutMinDist( info,STATS)
% 
% ***********************
% *****A*********D*******
% **********E************
% *****B*********C*******
% ***********************
% 

% Point A
point(1,1) = info.Width/3;
point(1,2) = info.Height/3;
% Point B
point(2,1) = info.Width/3;
point(2,2) = info.Height/3*2;
% Point C
point(3,1) = info.Width/3*2;
point(3,2) = info.Height/3*2;
% Point D
point(4,1) = info.Width/3*2;
point(4,2) = info.Height/3;
% Point E
point(5,1) = info.Width/2;
point(5,2) = info.Height/2;

[sizeSort,idx] = sort([STATS.Area], 'descend');

all_Dist = zeros(1,5);
minDist = inf;

    cenId=STATS(idx(1)).Centroid;
for i=1:5
    Dist = sqrt((cenId(1)-point(i,1))^2+(cenId(2)-point(i,2))^2);
    if(Dist < minDist)
        minDist = Dist;
    end
    all_Dist(1,i) = Dist;
end
