function dist_art(Data, ori_filetype, sal_imp_filetype, dir_ORI, dir_SAL, patch_size, ROName, k1, k2)
% clear all
% close all
tic;
% This function compute the local_distance by the bidirectional distance
% Local_distance(1,i) record the local distance of the i'th retargeted result by the bidirectional distance

% % Retargeting Operators: 1.CR    2.SV    3.MULTIOP   4.SC    5.SCL   6.SM    7.SNS   8.WARP
% 
% % % % % % % % % % % % 
% Parameter
RO =[1,2,3,4,5,6,7,8];
RONum =size(ROName,1);

for i = k1 : k2
 % obtain the saliency and important map of the original image
 % original image
 
 folder = regexp(char(Data.datasetNames(i)),'[a-zA-Z]+(_[a-zA-Z]+)+[a-zA-Z0-9]*|[a-zA-Z]+[0-9]*|','match');
 ori_FilePath = [dir_ORI,filesep,char(folder),filesep,char(folder),ori_filetype];
 ori_image = imread(ori_FilePath);
%  figure(1);
%  imshow(ori_image);
 %ori_sal_FilePath = [dir_SAL,filesep,char(data.name(i)),filesep,char(data.name(i)),'_RC',sal_imp_filetype];
 ori_sal_FilePath = [dir_SAL,filesep,char(folder),filesep,char(folder),'_RC',sal_imp_filetype];
 ori_sal = imread(ori_sal_FilePath);
%  figure;
%  imshow(ori_sal);
     for j = 1 : RONum
        % source image of retargeted result
        
        RO_ori_FilePath = [dir_ORI,filesep,char(folder),filesep,char(Data.datasetNames(i)),'_',char(ROName(RO(j))),ori_filetype];
        RO_sal_FilePath = [dir_SAL,filesep,char(folder),filesep,char(Data.datasetNames(i)),'_',char(ROName(RO(j))),'_RC',sal_imp_filetype]; 
        RO_ori_image = imread(RO_ori_FilePath);
%         figure(2);
%         imshow(RO_ori_image);
        RO_sal = imread(RO_sal_FilePath);       
        [L2_dist] = dist_art_weights(ori_image,RO_ori_image,ori_sal,RO_sal,patch_size);
        Local_dist(1,j) = L2_dist;
    end
     disp('ok');
     save([pwd,filesep,'art_weights',filesep,char(folder),'-loc-wei','.mat'],'Local_dist');  
   %  save([pwd,filesep,'Local_dis_lab_pz40',filesep,char(folder),'-loc','.mat'],'Local_dist_nwei');  
end
end
%  x = load([pwd,filesep,'Local_dis_lab_pz40',filesep,char(folder),'-loc-wei','.mat']);
