
clear all
close all
tic;

% % Retargeting Operators: 1.CR    2.SV    3.MULTIOP   4.SC    5.SCL   6.SM    7.SNS   8.WARP
% 
% % % % % % % % % % % % 
% Parameter
RO =[1,2,3,4,5,6,7,8];
RONum = size(RO,2);
DistNum = 5; % Ҫ岼еĶ룬Ź4ĵҪĵľ
ROName = {'cr','sv','multiop','sc','scl','sm','sns','warp'};
ori_filetype = '.bmp';
sal_imp_filetype = '.png';
load ('subjData-ref_37.mat');
fileNum = size(subjData.datasetNames,1);
dir_ORI = [pwd,filesep,'dataset-ORI'];
patch_size = 40;
for i = 1 : 37 % 19:37
 % obtain the saliency and important map of the original image
 % original image
 folder = regexp(char(subjData.datasetNames(i)),'[a-zA-Z]+(_[a-zA-Z]+)+[a-zA-Z0-9]*|[a-zA-Z]+[0-9]*|','match');
 ori_FilePath = [dir_ORI,filesep,char(folder),filesep,char(folder),ori_filetype];
 ori_image = imread(ori_FilePath);
%  figure;
%  imshow(ori_image);
     for j = 1 : RONum
        % source image of retargeted result
        RO_ori_FilePath = [dir_ORI,filesep,char(folder),filesep,char(subjData.datasetNames(i)),'_',char(ROName(RO(j))),ori_filetype];
        RO_ori_image = imread(RO_ori_FilePath);
      %  figure;
%         imshow(RO_ori_image);
        % the distance between the patch from the original image and the retargeted image
%         ori_patch =  ori_image(1:patch_size,1:patch_size,1:3);
%         ro_ori_patch = RO_ori_image(1:patch_size,1:patch_size,1:3);
%         figure;
%         imshow(ori_patch);
%         figure;
%         imshow(ro_ori_patch);       
         [rows,cols,dims] = size(ori_image);
         ro_ori_patch = imresize(RO_ori_image,[rows,cols]);
         ori_patch = ori_image;
         [L2_dist,SSIM_dist] = L2SSIM_ful(ori_patch,ro_ori_patch);
        R = double(ori_patch)/2^8;
        R = rgb2gray(R);
        T = double(ro_ori_patch)/2^8;
        T = rgb2gray(T);     
        res = Contents_fun(T,R);   
        distance(j,1).L2 = L2_dist;  % smaller L2 means better retargeted result
        distance(j,1).SSIM = SSIM_dist; % bigger SSIM means better retargeted result
        distance(j,1).QMOS = res.Q_MOS;  % bigger QMOS means better retargeted result               
     end
     disp('ok');
     save([pwd,filesep,'ssim_qmos_distance',filesep,char(folder),'-dis','.mat'],'distance');  
end

x = load([pwd,filesep,'ssim_qmos_distance',filesep,char(folder),'-dis','.mat']);
