function fun_sym_dist(Data,tail_name)

%image_name = 'Johanneskirche';
% image_name = 'buddha';
% image_name = 'foliage';
% image_name = 'glasses';
% image_name = 'SetAngle';
% image_name = 'tajmahal';
% tail_name(1).tail = '_warp.bmp';
% tail_name(2).tail = '_cr.bmp';
% tail_name(3).tail = '_sc.bmp';
% tail_name(4).tail = '_scl.bmp';
% tail_name(5).tail = '_sm.bmp';
% tail_name(6).tail = '_sns.bmp';
% tail_name(7).tail = '_sv.bmp';
% tail_name(8).tail = '_mop.bmp';
%image_name =  regexp(char(data(1)),'[a-zA-Z]+(_[a-zA-Z]+)+[a-zA-Z0-9]*|[a-zA-Z]+[0-9]*|','match');
%image_name = Data.;
image_name= char(Data.datasetNames(1));
num_j = 0;
for j = 3 : 3 : 14 % j can be varied from a small valut to a big one to help user to chose the best symmetry features desriptions
    num_j = num_j + 1;
for k = 1 : 1  % k describes the numbers of image included in Data
%name = [image_name, '_warp.bmp'];
%tail = tail_name(k).tail;
tail = tail_name;
name = [image_name,tail];
%I = imread(fullfile(vl_root,'data','SetAngle_cr.bmp')) ;
I = imread(fullfile(vl_root,'data','tvcg', name)) ;

[filter_sym_region] = fun_mesr_region(I, j);
[x,num] = size(filter_sym_region);
dist = zeros(num,num);
diff_hw = zeros(num,num);
all_dist_sym = zeros(num,num);
%%
for idx = 1 : num
% idx = 2;
 idx_patch = filter_sym_region(idx).patch;
 [idx_height, idx_width,dim] = size(idx_patch);
idx_patch = double(idx_patch(:,:,:))./255.0;
% figure; subplot(1,2,1);
% imshow(idx_patch);

tic
for i = 1 : num
    if (i == idx) 
        dist(idx,i)= inf;
        diff_hw(idx,i) = inf;
    else
        patch = filter_sym_region(i).patch;
        [h,w,dim] = size(patch);
        res_patch = imresize(patch,[idx_height,idx_width]);
       % res_patch = res_patch ./255.0;
        res_patch = double(res_patch)./255.0;
        t1 = abs(res_patch(:,:,1) - idx_patch(:,:,1));
        t2 = abs(res_patch(:,:,2) - idx_patch(:,:,2));
        t3 = abs(res_patch(:,:,3) - idx_patch(:,:,3));
        diff_h = abs(h - idx_height)./ (h + idx_height);
        diff_w = abs(w - idx_width)./ (w + idx_width);
       % t = sqrt((diff_h - diff_w).^2);
        t = abs(diff_h - diff_w)./(diff_h + diff_w);
        diff_hw(idx,i) = t;
        area = idx_height * idx_width;
        dist(idx,i) = (sum(sum(t1))./area + sum(sum(t2))./area + sum(sum(t3))./area)/3;             
        
    end   
    
    
end
all_dist_sym(idx,:) = diff_hw(idx,:) + dist(idx,:);
best = min(all_dist_sym(idx,:));
idx_best = find(all_dist_sym(idx,:) == best);
%disp(num2str(idx));
best_patch = filter_sym_region(idx_best).patch;
final_dist(1,idx) = best;
final_dist(2,idx) = idx_best;
best_patch_re = imresize(best_patch, [idx_height,idx_width]);
% subplot(1,2,2);
% imshow(best_patch_re);
toc
end
sym_dist = sum(final_dist(1,:))./ num;
all_sym(num_j,k) = sym_dist;

% save(([pwd,filesep,'result',filesep,num2str(j), name,'.mat']),'sym_dist');
%  disp('finish!');
end

disp('finish the j is ');
disp(num2str(j));

end
save(([pwd,filesep,'sym_dist',filesep,image_name,'.mat']),'all_sym');
end


