
function salient_content(Data, ori_filetype, sal_imp_filetype, dir_ORI, dir_SAL, dir_IMP_Areas,ROName, k1,k2)

%clear all
%close all
%tic;

% % % % % % % % % % % % 
% Parameter
RO =[1,2,3,4,5,6,7,8];
DistNum = 5; % Ҫ岼еĶ룬Ź4ĵҪĵľ
%ROName = {'cr','sv','multiop','sc','scl','sm','warp','ours'};
%ROName = {'ours'}; 
RONameT = ROName';
RONum =size(ROName,1);

%fileNum = size(Data.datasetNames,1);

ori_HSV = zeros(1,256);
ori_Area = 0;
ro_HSV = zeros(RONum,256); % ro_HSVi,j洢iͼjŽҪɫֱͼ
ro_Area = zeros(RONum,1); % ro_Area(i,j)洢iͼjŽҪ
ro_Dist = zeros(RONum,DistNum);% ro_Dist(i,j)洢iͼjŽҪ5ؼľ루4ŹĽ+1ĵ㣩

for i = k1 : k2
    tic
 % obtain the saliency and important map of the original image
 % original image

 folder = regexp(char(Data.datasetNames(i)),'[a-zA-Z]+(_[a-zA-Z]+)+[a-zA-Z0-9]*|[a-zA-Z]+[0-9]*|','match');
 ori_FilePath = [dir_ORI,filesep,char(folder),filesep,char(folder),ori_filetype];
 ori_image = imread(ori_FilePath);
  figure(1);
 subplot(2,3,1);
 imshow(ori_image);
 
 % important map
 imp_areas_FilePath = [dir_IMP_Areas,filesep,char(folder),filesep,char(folder),'_RCC',sal_imp_filetype];
 imp_areas_image = imread(imp_areas_FilePath);
 subplot(2,3,2);
 imshow(imp_areas_image); 
  
 % saliency map 
 sal_FilePath = [dir_SAL,filesep,char(folder),filesep,char(folder),'_RC',sal_imp_filetype];
 sal_image = imread(sal_FilePath);
 subplot(2,3,3);
 imshow(sal_image);
 
 
 % the areas and hsv of important areas for the original image
  temp_imp = logical(imp_areas_image);
  [orihistHSV,oriBWarea] = hsvhist(ori_image,temp_imp,0);
  ori_HSV = orihistHSV; % ҪHSV
  ori_Area = oriBWarea; % Ҫ
  % save([pwd,filesep,'IP',filesep,char(folder),'.mat'],'ori_HSV','ori_Area');
   
 
%%

% obtain the saliency and important map of the retargeted images

    for j = 1 : RONum
        % source image of retargeted result
        RO_ori_FilePath = [dir_ORI,filesep,char(folder),filesep,char(Data.datasetNames(i)),'_',char(ROName(RO(j))),ori_filetype];
        RO_ori_image = imread(RO_ori_FilePath);
        subplot(2,3,4);
        imshow(RO_ori_image);
        
        % important areas of retargeted result
        
        RO_imp_areas_FilePath = [dir_IMP_Areas,filesep,char(folder),filesep,char(Data.datasetNames(i)),'_',char(ROName(RO(j))),'_RCC',sal_imp_filetype];
        RO_imp_areas_image = imread(RO_imp_areas_FilePath);
        ROInfo = imfinfo(RO_imp_areas_FilePath);
        subplot(2,3,5);
        imshow(RO_imp_areas_image);        
            
        % saliency of retargeted result
        RO_sal_FilePath = [dir_SAL,filesep,char(folder),filesep,char(Data.datasetNames(i)),'_',char(ROName(RO(j))),'_RC',sal_imp_filetype];
        RO_sal_image = imread(RO_sal_FilePath);
        subplot(2,3,6);
        imshow(RO_sal_image);
        
        temp_ro_imp = logical(RO_imp_areas_image);
        [ROhistHSV,ROBWarea] = hsvhist(RO_ori_image,temp_ro_imp,0);
        ro_HSV(j,:) = ROhistHSV;
        ro_Area(j,1) = ROBWarea;
     
        % the quality value computed by layout
        [ROL,ROLabNum] = bwlabel(temp_ro_imp,4);
        layout_Dist = zeros(1,5);
        if ROLabNum > 0
           ROSTATS = regionprops(ROL,'basic');
           layout_Dist = LayoutMinDist(ROInfo,ROSTATS);        
        end
        ro_Dist(j,:) = layout_Dist;
    end

  save([pwd,filesep,'IP',filesep,char(folder),'_f','.mat'],'ori_HSV','ori_Area','ro_HSV','ro_Area','ro_Dist','RONameT');
  disp('The important metric finished.');
  toc;
end

end
