% ע⣺ÿʹ֮ǰһvl_setup.m,vlװȥ
% this algorithm just do the following processes:
% (1) search the matched patches from the known image of an image data
% (2) just paste them on the corresponding position of the unknown
% image,without warping and without process the overlap patches
% (3) for the overlap patches, we just paste one by one, namely the current
% patch will be covered by the next matched patch

% matched patch is the patch from the known image to recontruct the
% unknown image
% matching patch means the patched of the unknown image, which is asking
% matching from the known image


clear all
close all


%%
% read and plot the keypoints of the first image 
tic
pfx = fullfile(vl_root,'data','SetAngle_cr.bmp') ;
Ia = imread(pfx) ;
Ia_source = Ia;
figure;
image(Ia) ;
Ia = single(rgb2gray(Ia)) ;
[fa, da] = vl_sift(Ia) ;
% display the keypoints of the first image 
ha1 = vl_plotframe(fa(:,:)) ; 
ha2 = vl_plotframe(fa(:,:)) ; 
set(ha1,'color','r','linewidth',3) ;
set(ha2,'color','y','linewidth',2) ;

[dim,num] = size(fa);
flag = zeros(num,1);

flag_fa_high = find((fa(3,:) > 10)  );
flag_fa_low = find(fa(3,:) < 3);

flag(flag_fa_high) = 1;
flag(flag_fa_low) = 1;
flag_fa = 1 - flag;
t = 1;
for i = 1 : num
    if (flag_fa(i,1) == 1) 
        fa_fit(:,t) = fa(:,i);
        t = t + 1;
    end   
end
disp('good');
toc
figure;
image(Ia_source);
ha1 = vl_plotframe(fa_fit(:,:)) ; 
ha2 = vl_plotframe(fa_fit(:,:)) ; 
set(ha1,'color','r','linewidth',3) ;
set(ha2,'color','y','linewidth',2) ;



















%%

% %%
% %read and plot the keypoints of the second image 
% pfx = fullfile(vl_root,'data','b.jpg') ;
% Ib = imread(pfx) ;
% Ib_source = Ib;
% figure;
% image(Ib) ;
% Ib = single(rgb2gray(Ib)) ;
% [fb, db] = vl_sift(Ib) ;
% 
% % dsplya the keypoints of the second image 
% hb1 = vl_plotframe(fb(:,:)) ; 
% hb2 = vl_plotframe(fb(:,:)) ; 
% set(hb1,'color','r','linewidth',3) ;
% set(hb2,'color','y','linewidth',2) ;
% % 
% % 
% %%
% % match contains two rows. for each column, the first row stores the index of
% % the descriptor in fa, and the second row is the index of the decriptor in
% % fb which is the closest descriptor to the one denoted by the first rows.
% 
% [matches, scores] = vl_ubcmatch(da, db) ;
% 
% %%
% 
% % display the matched patches on the first and the second image 
% 
% % the numbers of patches being matched between the first and second image 
% Num_match = size(matches,2);
% 
% % set the first image as the background 
% figure;
% image(Ia_source) ;
% 
% for i = 1 : Num_match
%     
% %  the first row stores the index of the patches from the first image being matched by the
% %  second image 
% 
% i_a = matches(1,i);
% 
% ha1 = vl_plotframe(fa(:,i_a)) ; 
% ha2 = vl_plotframe(fa(:,i_a)) ; 
% set(ha1,'color','r','linewidth',3) ;
% set(ha2,'color','y','linewidth',2) ; 
% 
% end
% 
% %  set the secong image as the background 
% figure;
% image(Ib_source) ;
% 
% for i = 1 : Num_match
%  %  the first row stores the index of the patches from the second image
%  %  used to match the patches of the first image 
% i_b = matches(2,i);   
% 
% hb1 = vl_plotframe(fb(:,i_b)) ; 
% hb2 = vl_plotframe(fb(:,i_b)) ; 
% set(hb1,'color','r','linewidth',3) ;
% set(hb2,'color','y','linewidth',2) ;
% 
% end
% 
% 
% 
% %%
% % build the background of the reconstruced image.
% % select the first matching patch of the second image, to help form the
% % background 
% i = 1;
% i_matched = matches (2,i);
% r = round(fb(3,i_matched));
% 
% % the four boundaries of the rectangle used to include the matching patch
% X_b = round(fb(1,i_matched)) - r;
% X_t = round(fb(1,i_matched)) + r;
% Y_b = round(fb(2,i_matched)) - r;
% Y_t = round(fb(2,i_matched)) + r;
% 
% % display this matching patch 
% Patch = Ib_source (Y_b:Y_t,X_b:X_t,:);
% figure;
% imshow(Patch);
% 
% 
% % search the position of the matched patch with the first matching patch,
% % i_source
% i_source = matches (1,i);
% 
% % fa (1,i_source) stores the x-coordinate of the center of matched patch
% % fa (2,i_source) stores the y-coordinate of the center of matched patch
% 
% XX_b = round(fa(1,i_source)) - r;
% XX_t = round(fa(1,i_source)) + r;
% YY_b = round(fa(2,i_source)) - r;
% YY_t = round(fa(2,i_source)) + r;
% % 
% % % store the matching patch on the top-left corner and the bottom-right
% % % corner
% % 
% Recon_image(1:5,1:5,:) = Ib_source (Y_b:Y_t,X_b:X_t,:);
% Recon_image(474:478,636:640,:) = Ib_source (Y_b:Y_t,X_b:X_t,:);
% 
% figure;
% imshow (Recon_image);
% Recon_image2 = Recon_image;
% %%
% i = 1;
% i_matched = matches (2,i);
% r = round(fb(3,i_matched));
% 
% % the four boundaries of the rectangle used to include the matching patch
% X_b = round(fb(1,i_matched)) - r;
% X_t = round(fb(1,i_matched)) + r;
% Y_b = round(fb(2,i_matched)) - r;
% Y_t = round(fb(2,i_matched)) + r;
% 
% % display this matching patch 
% Patch = Ib_source (Y_b:Y_t,X_b:X_t,:);
% figure;
% imshow(Patch);
% 
% % r = round(fb(3,i_matched));
% % matlab ִСд
% se = strel('disk',r,0);
% a = getnhood(se);
% c(:,:,1) = uint8(double(a).*double(Patch(:,:,1)));
% c(:,:,2) = uint8(double(a).*double(Patch(:,:,2)));
% c(:,:,3) = uint8(double(a).*double(Patch(:,:,3)));
% figure;
% imshow(c);
% 
% 
% %%
% 
% 
% % %%
% % % paste the matched patches on the empty background formed by the last
% % % process
% % % step: 
% % 
% % for i = 1 : Num_match
% % 
% % % search the index (i_matched) of the matched patch of the second image  
% % i_matched = matches (2,i);
% % % obtain the radius of the (i_matched) matched patch  
% % 
% % r = round(fb(3,i_matched));
% % 
% % % compute the rectangle of the (i_matched) patch
% % X_b = round(fb(1,i_matched)) - r;
% % X_t = round(fb(1,i_matched)) + r;
% % Y_b = round(fb(2,i_matched)) - r;
% % Y_t = round(fb(2,i_matched)) + r;
% % 
% % % Patch = Ib_source (Y_b:Y_t,X_b:X_t,:);
% % % figure;
% % % imshow(Patch);
% % 
% % % search the index (i_source) of the matching patch of the reconstructed
% % % image  being matched by the (i_matched) patch
% % 
% % i_source = matches (1,i);
% % 
% % center_x = round (fa(1,i_source));
% % center_y = round (fa(2,i_source));
% % 
% % % the rectangle should be pasted the (i_matched)  matched patch 
% % 
% % XX_b = round(fa(1,i_source)) - r;
% % XX_t = round(fa(1,i_source)) + r;
% % YY_b = round(fa(2,i_source)) - r;
% % YY_t = round(fa(2,i_source)) + r;
% % 
% % Recon_image(YY_b:YY_t,XX_b:XX_t,:) = Ib_source (Y_b:Y_t,X_b:X_t,:); %red (:,:,:);
% % 
% % end
% % 
% % figure;
% % imshow (Recon_image);
% % 
% % %% add another image into the image data 
% % tic
% % 
% % filepath = 'data\house\';
% % filename = 'house';
% % 
% % % the number of the files should used to reconstruct the image 
% % picnum = 10;
% % 
% % 
% % % pfx(1) = fullfile(vl_root,'data','hongwa.jpg') ;
% % % pfx(2) = fullfile(vl_root,'data','zhuan.jpg') ;
% % 
% % for i = 1 : picnum
% % 
% % % match the new input image of a data with the unknown image
% % Ic = imread([filepath, filename, '_', num2str(i),'.jpg']);
% % Ic_source = Ic;
% % 
% % Ic = single(rgb2gray(Ic)) ;
% % [fc, dc] = vl_sift(Ic) ;
% % [matches, scores] = vl_ubcmatch(da, dc) ;
% % Num_matches = size (matches,2);
% % %% display the matched regions.
% % 
% % % figure;
% % % image(Ia_source) ;
% % % for k = 1 : Num_matches
% % %     
% % % i_a = matches(1,k);
% % % ha1 = vl_plotframe(fa(:,i_a)) ; 
% % % ha2 = vl_plotframe(fa(:,i_a)) ; 
% % % set(ha1,'color','r','linewidth',3) ;
% % % set(ha2,'color','y','linewidth',2) ; 
% % % 
% % % end
% % % 
% % % figure;
% % % image(Ic_source) ;
% % % for k = 1 : Num_matches
% % %     
% % % i_c = matches(2,k);
% % % ha1 = vl_plotframe(fc(:,i_c)) ; 
% % % ha2 = vl_plotframe(fc(:,i_c)) ; 
% % % set(ha1,'color','r','linewidth',3) ;
% % % set(ha2,'color','y','linewidth',2) ; 
% % % 
% % % end
% % 
% % %%
% % for j = 1 : Num_matches
% %     
% % % obtain the matched patch
% % i_matched = matches (2,j);
% % r = round(fc(3,i_matched));
% % 
% % X_b = round(fc(1,i_matched)) - r;
% % X_t = round(fc(1,i_matched)) + r;
% % Y_b = round(fc(2,i_matched)) - r;
% % Y_t = round(fc(2,i_matched)) + r;
% % 
% % % obtain the position of the matching patch 
% % i_source = matches (1,j);
% % center_x = round (fa(1,i_source));
% % center_y = round (fa(2,i_source));
% % XX_b = round(fa(1,i_source)) - r;
% % XX_t = round(fa(1,i_source)) + r;
% % YY_b = round(fa(2,i_source)) - r;
% % YY_t = round(fa(2,i_source)) + r;    
% % 
% % % directly paste the matched patch on the position of matching patch 
% % 
% % Recon_image2(YY_b:YY_t,XX_b:XX_t,:) = Ic_source (Y_b:Y_t,X_b:X_t,:);   
% % Recon_image(YY_b:YY_t,XX_b:XX_t,:) = Ic_source (Y_b:Y_t,X_b:X_t,:);    
% % 
% % 
% % end
% % %% display the matches produced by the new input image 
% % 
% % % figure;
% % % imshow (Recon_image2);
% % 
% % %% display the new reconstructed image after using the new input image 
% % 
% % % figure;
% % % imshow (Recon_image);
% % 
% % 
% % end
% % %%
% % t = toc;
% % disp (['the time is :', num2str(t)]);
% % figure;
% % imshow (Recon_image);
% % 
